<template>
  <div style="height: 100%;" class="on-boarding">
    <v-app-bar elevation="0" align="center" class="join-header" justify="">
      <v-toolbar-title>
        <router-link to="/"> </router-link>
      </v-toolbar-title>
      <!-- <v-spacer></v-spacer> -->
      <span class="ml-5">{{ steps[currentStep].header }}</span>
    </v-app-bar>
    <div class="on-boarding-header">
      <v-container>
        <v-row justify="center">
          <v-col>
            <h2>
              {{ steps[currentStep].title }}
              {{ currentStep === 0 ? user.firstName : '' }}
            </h2>
            <p class="title">{{ steps[currentStep].subTitle }}</p>
          </v-col>
        </v-row>
      </v-container>
    </div>
    <v-container>
      <v-row justify="center">
        <v-col xs="12" md="8">
          <LicensedTherapist
            v-if="currentStep === 0"
            :profile="profile"
            :next="next"
            @update="updateProfile"
          />
          <CircleType
            v-if="currentStep === 1"
            :profile="profile"
            :next="next"
            @update="updateProfile"
          />
          <About
            v-if="currentStep === 2"
            :profile="profile"
            @update="updateProfile"
          />
          <ProfileImage v-if="currentStep === 3" />
          <Experience
            v-if="currentStep === 4"
            :profile="profile"
            @update="updateProfile"
          />
        </v-col>
      </v-row>
    </v-container>

    <v-footer height="auto" class="footer">
      <v-container>
        <v-row>
          <v-btn v-if="currentStep > 0" outlined @click="back">Back</v-btn>
          <v-spacer></v-spacer>
          <v-btn v-if="currentStep !== 4" outlined @click="next">Next</v-btn>
          <v-btn v-if="currentStep === 4" outlined @click="finish"
            >Finish</v-btn
          >
        </v-row>
      </v-container>
    </v-footer>
  </div>
</template>

<script>
import { mapState } from 'vuex'
import LicensedTherapist from './LicensedTherapist'
import ProfileImage from './ProfileImage'
import Experience from './Experience'
import About from './About'
import CircleType from './CircleType'

export default {
  name: 'PractitionerOnboarding',
  components: {
    LicensedTherapist,
    ProfileImage,
    Experience,
    About,
    CircleType
  },
  computed: {
    ...mapState('authentication', ['user'])
  },
  data: () => ({
    currentStep: 0,
    steps: [
      {
        step: 0,
        title: `Hi`,
        subTitle: "Let's build your profile",
        header: 'Personal Information'
      },
      {
        step: 1,
        title: 'Circle Types',
        subTitle: 'What type of circle you looking to create?',
        header: 'Circle'
      },
      {
        step: 2,
        title: 'About you',
        subTitle: 'Write your main practice & about you',
        header: 'Personal Information'
      },
      {
        step: 3,
        title: 'Profile image',
        subTitle: 'Add your best photo',
        header: 'Personal Information'
      },
      {
        step: 4,
        title: 'license and credentials',
        subTitle:
          'Add any qualifications you have and where did you get it from',
        header: 'Personal Information'
      },
      {
        step: 5,
        title: 'Special Knowledge ',
        subTitle: 'Add any supported skills and knowledge you have',
        header: 'Personal Information'
      }
    ],
    profile: {
      licensedTherapist: false,
      about: null,
      circleTypes: []
    },
    finishing: false
  }),
  created() {},
  mounted() {
    if (!this.user) {
      this.$router.go(0)
    }
  },
  methods: {
    // ...mapActions('facilitatorProfile', ['update']),
    next() {
      this.checkDuplicates()
      if (this.currentStep < this.steps.length - 1) {
        this.currentStep += 1
      }
    },
    back() {
      this.checkDuplicates()
      if (this.currentStep > 0) this.currentStep -= 1
    },
    updateProfile(name, val) {
      const p = this.profile
      p[name] = val
      this.profile = p
    },
    finish() {
      if (!this.finishing) {
        this.checkDuplicates()
        this.profile.id = this.user.uid
        this.finishing = true
        this.$store
          .dispatch('facilitatorProfile/update', this.profile)
          .then(() => {
            this.finishing = false
            this.$router.push('/facilitator')
          })
          .catch(() => {
            this.finishing = false
          })
      }
    },
    checkDuplicates() {
      if (
        this.currentStep === 1 &&
        this.profile.circleTypes &&
        this.profile.circleTypes.length > 0
      ) {
        for (let i = 0; i < this.profile.circleTypes.length; i += 1) {
          const type = this.profile.circleTypes[i]
          if (type === null) {
            this.profile.circleTypes.splice(i)
          }
        }
      }
      if (
        this.currentStep === 4 &&
        this.profile.experiences &&
        this.profile.experiences.length > 0
      ) {
        for (let i = 0; i < this.profile.experiences.length; i += 1) {
          const experience = this.profile.experiences[i]
          if (experience === null) {
            this.profile.experiences.splice(i)
          }
        }
      }
    }
  }
}
</script>

<style lang="scss">
.on-boarding {
  .on-boarding-header {
    min-height: 8rem;
    text-align: center;
    color: #fff;
    background: #673ab7;
  }
  .footer {
    min-height: 60px;
    background: #fff;
    bottom: 0;
    position: absolute;
    width: 100%;
    border-top: 1px solid #e2e2e2;
    padding: 0;
  }
}
</style>
